=== AMP for WP - Accelerated Mobile Pages ===
Contributors: mohammed_kaludi, ahmedkaludi, ampforwp
Tags: AMP, accelerated mobile pages, mobile, amp project, google amp, amp wp, google, plugin, SEO
Donate link: https://www.paypal.me/Kaludi/25
Requires at least: 3.0
Tested up to: 5.3.2
Stable tag: 1.0.4
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html

AMP for WP is the most recommended AMP plugin by the community. Automatically add Accelerated Mobile Pages (Google AMP Project) functionality on your WordPress site.

== Description ==
AMP for WP automatically adds Accelerated Mobile Pages (Google AMP Project) functionality to your WordPress site. AMP makes your website faster for Mobile visitors.

[What's New in this Version?](https://ampforwp.com/new/) | [Priority Support](https://ampforwp.com/priority-support/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin) | [View Demo](https://ampforwp.com/demo/) | [Screenshots](https://wordpress.org/plugins/accelerated-mobile-pages/screenshots/) | [Community](https://ampforwp.com/help-center/)

<strong>Extensions</strong><br>
Some useful extensions to extend AMP features, check [AMP Adsense Support](https://ampforwp.com/advanced-amp-ads/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin), [Contact Form 7 Support](https://ampforwp.com/contact-form-7/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin), [Email Opt-in Support](https://ampforwp.com/opt-in-forms/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin) and [Call To Action Support](https://ampforwp.com/call-to-action/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin). To view more, go to our [Extensions page](https://ampforwp.com/extensions/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin).

<strong>Support</strong><br>
We try our best to provide support on WordPress.org forums. However, We have a special [community support](https://ampforwp.com/help-center/) where you can ask us questions and get help about your AMP related questions. Delivering a good user experience means a lot to us and so we try our best to reply each and every question that gets asked.

<strong>Bug Reports</strong><br>
Bug reports for AMP for WP are [welcomed on GitHub](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages). Please note GitHub is _not_ a support forum, and issues that aren't properly qualified as bugs will be closed.


= Features: =

* NEW - Gutenberg Support
* NEW - Divi and Elementor Support [More Info](https://ampforwp.com/amp-pagebuilder-compatibility/)
* NEW - Improved CSS Optimization (Tree Shaking)
* NEW - Google Fonts Support For All Designs
* NEW - Addthis Sharing Support
* NEW - AMP Infinite Scroll Support
* NEW - Photo Gallery by 10Web Support 
* NEW - MEWE social network Support 
* NEW - GDPR Compliance
* Out of the box compatiblity for Yoast SEO, All in One Seo, Rank Math, Genesis, SEOPress, Bridge Qode SEO, The SEO Framework and Squrilly SEO Plugin.
* Introducing Page Builder 3.0 for AMP! [Learn More & Video](https://ampforwp.com/tutorials/article/amp-page-builder-installation/)
* New Default Theme for AMP called Swift
* 3 Pre-built AMP Layouts for Business websites and landing pages 
* OneSignal Push Notifications integration 
* Advanced WooCommerce Support [More Info](https://ampforwp.com/woocommerce/)
* Gravity Forms Support [More Info](https://ampforwp.com/gravity-forms/)
* AMP Plugins Manager - Which allows you to disable a specific plugin functionality only in the AMP version
* Structured Data Options
* Page Break / NextPage (Pagination) Support
* Contact Form 7 Support [More Info](https://ampforwp.com/contact-form-7/)
* Graviry Form Support [More Info](https://ampforwp.com/gravity-forms/)
* Caldera Form Support [More Info](https://ampforwp.com/caldera-forms-for-amp/)
* Ninja Form Support [More Info](https://ampforwp.com/ninja-forms/)
* Facebook Comments Support
* Github Gist Support
* Email Opt-in Subscription form support in AMP added
* Call to Action boxes and notification bars 
* 9 Advertisement sizes - 2 More AD slots added recently
* Comments Forms in AMP.
* Native AMP Search functionality.
* Design 3 [Watch the Video Overview](https://www.youtube.com/watch?v=ub1pwskt3Rc)
* Disqus Comments Support
* Google Tag Manager Support
* Page, Category & Tags Support Added
* Custom AMP Editor - Which allows you to override your Content that you had written in Post or page, so you can add the different content just for AMP.
* Mobile Redirection -  More than 50% of your traffic is from mobile and you aren’t doing anything to improve their user experience, which means you are falling behind on SEO and it can result in lower SERPS. Lightning fast mobile version means faster User experience means more engagement which directly results in the lower bounce rate.
* Custom Post Type Support 
* Star Ratings
* Drag & Drop Page builder Added 
* 4 Designs for AMP 
* AMP WooCommerce Support 
* Switch on/off Support for Pages & Posts on AMP
* Translation Panel & RTL
* Internal AMP linking - You can browse AMP pages internally
* Related posts below the post
* Recent Comments list
* Automatically integrate AMP to your website.
* Google Adsense (AMP-AD) Support with 4 different Ad slots across the layout! The First Plugin to have this capability.
* Built in MGID Ads Support with 6 different ad slots.
* Google Analytics Support.
* User Friendly Theme Options Panel.
* Unlimited Color Scheme.
* Image Logo Upload.
* Supports Posts and Pages and other custom post types.
* Proper rel canonical tags which means that Google know the original page.
* Overlay Navigation Menu bar.
* Social Sharing in the Single.
* Sexy Design.
* Separate WordPress Menu for AMP version.
* Page builder & Shortcodes Compatibility.
* Carousel support for Gallery.
* Better Image stretching and resizing.
* Youtube Video Embed Support.
* Vine Embed Support.
* Twitter oembed Support.
* Instagram Embed Support.
* Facebook Video Embed Support.
* RTL Support
* Custom AMP FrontPage
* Notifications
* Alexa Metrics, Chartbeat, Hi-stats, Yandex Metrika, Piwik, Segment.com, StatCounter, Effective Measure and comScore Builtin Support
* Incontent & DoubleClick Support
* Great Support & Active Development.
* Widgets & WooCommerce 
* Breadcrumb Support added 
* Facebook Instant Articles Support Added
* AMP Installation Wizard that makes it easy to setup for new users.
* Category base remover support
* Tag base remover support
* 7 New Social Media Integrations added (Reddit, Tumblr, Telegram, Digg, StumbleUpon, Wechat, Viber) 
* AMP Theme Framework Core Support Added. You can now create AMP templates of your own in just minutes. **[More](https://ampforwp.com/amp-theme-framework/)**
* NEW - Make AMP & Non-AMP Same with just one click! 
* NEW - Allows you to use AMP as primary website!


**[JOIN CHAT GROUP COMMUNITY](https://ampforwp.com/community/)**: Purpose of this group is to get proper suggestions and feedback from plugin users and the community so that we can make the plugin even better.

= Getting Started: =
**[1. User Documentation:](https://ampforwp.com/help/)** The AMP for WordPress plugin is easy to setup but we have some tutorials and guides prepared for you which will help you dive deep with the plugin.

**[2. Developer Docs:](https://ampforwp.com/tutorials/article-categories/developer-documentation/)** We have created special documentations for developers and semi technical users who are willing to modify the plugin according to their own needs.

**[3. Support:](https://ampforwp.com/help-center/)** We try our best to provide support on WordPress.org forums. However, We have a special community support where you can ask us questions and get help about your AMP related questions. Delivering a good user experience means a lot to us and so we try our best to reply each and every question that gets asked.

**[4. Premium Support:](https://ampforwp.com/priority-support/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin)** We will personally take care that your website’s AMP version is perfectly validated. We will make sure that your AMP version gets approved and indexed by Google Webmaster Tools properly and we will even keep an eye on AMP updates from Google and implement them into your website.

== Credits ==
Some code used in this plugin was forked from 'AMP for WordPress' plugin https://wordpress.org/plugins/amp/ - License URI: http://www.gnu.org/licenses/gpl-2.0.html.
Mobile & Tablet detection library used https://github.com/serbanghita/Mobile-Detect - License URI: https://github.com/serbanghita/Mobile-Detect/blob/master/LICENSE.txt
PHP CSS Parser library used https://github.com/sabberworm/PHP-CSS-Parser - License URI: https://github.com/sabberworm/PHP-CSS-Parser#license (PHP-CSS-Parser is freely distributable under the terms of an MIT-style license.)

== Installation ==
**[Visit Help area for the Documentation:](https://ampforwp.com/help/)**

[youtube https://www.youtube.com/watch?v=Em1nsE_KaKw]

**[Visit Help area for the Documentation:](https://ampforwp.com/help/)**


== Frequently Asked Questions ==

= Can I add analytics? =

Yes, you easily can. In fact, we have support for 12 Analytics companies. Including Google Analytics, Facebook Pixel, StatCounter, QuantCast, Chartbeat, comScore to list a few. Also, we have Google Tag Manager (GTM) support as well.

= Can I add Ads in my AMP pages? =

Yes, you can. We have 6 ad placement slots that are built in and strategically placed to get maximum views. Also, we have [an extension](https://ampforwp.com/advanced-amp-ads/) from which you can insert ads between the content, will get more ad slots and also add custom banners to all the available slots.


= Can I extend/Change the AMP design, so it suits my needs? =

Yes, you easily can. We have created this plugin in such a way that it can easily be extended. Check out our [AMP Theme Framework](https://ampforwp.com/tutorials/article/getting-started-amp-framework/)


= Do you have any prebuilt designs? =

Yes, we have AMP themes section where we have free and paid designs available. We also update it regularly. You can check it out our [AMP Themes](https://ampforwp.com/themes)


= I'm a developer and I want to add custom functionality for a client, can I do that? =

Yes, of course. This plugin is very developer friendly, we have lots of hooks and filters that you can use to extend and customize according to the requirements. Also, we have [developer documentation](https://ampforwp.com/tutorials/article-categories/developer-documentation/) which we update regularly.


= How do I report bugs and suggest new features? =

You can report the bugs [here](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages/issues)

= Will you Add New features to my request? =

Yes, Absolutely! We would suggest you send your feature request by creating an issue in [Github](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages/issues/new/) . It helps us organize the feedback easily.


= How do I get in touch? =

You can contact us from [here](https://ampforwp.com/contact/)


== Screenshots ==
1. AMP Homepage
2. AMP Single Post
3. Post Navigation in Single
4. Sticky Social sharing icons
5. Overlay Navigation menu sidebar.
6. Page builder of the Single article. You can drag and drop any element.
7. Single post of Design One
8. GTMetrix Performance Report
9. Google PageSpeed Insight report for AMP
10. Homepage of Design One
11. Pingdom Speed Report for AMP

== Changelog ==

= 1.0.4 (26th December 2019) =
* Fixed: When Optimize CSS (beta) option is enabled AMP page is getting blank #3994

= 1.0.3 (23th December 2019) =
* Improvement: Filter in search form #3948
* Improvement: Improvement of jetpack social icons #3907
* Improvement: Need to add a Filter in amp tree shaking for adding custom CSS. #3971
* Fixed: Icomoon.ttf is preloaded in Design 1 and Design 2. #3945
* Fixed: Search translate text option is visible in swift but unused #3934
* Fixed: Category module has minor bugs after the update. #3880
* Fixed: Improvements required in RTL support in AMP #3938
* Fixed: Save buttons are not looking good after WP 5.3 update #3985
* Fixed: Video widget support in AMP #3841
* Fixed: Time is not working in published date notice #3956
* Fixed: Recoverable fatal error: Object of class DOM Node List could not be converted to string #3968
* Fixed: In Amp struture data option if we added any schema then description generated in html format #3937
* Fixed: Select Taxonomy and Select Category is getting blank in the category module of AMP page builder #3986
* Fixed: Notice: Undefined offset: 0 in class-amp-post-template.php on line 378 #3992
* Fixed: Undefined variable: designCss #3961
* Fixed: Open Graph title is not displaying correctly with SEOPress in AMP. #3966

= 1.0.2 (19th December 2019) =
* Improvement: Need to add wordpress default Gutenburg editor 'Block' settings Compatibility in AMP #3320
* Improvement: Need to make compatibility with the Imagify plugin #3908
* Improvement: Taxonomy support in AMP Page Builder category module #3310
* Improvement: Add support of fallback images in AMP #3790
* Improvement: General code improvements part 3 #3941
* Improvement: Drop down support in Alternative Menu in Mobile view. #2768
* Fixed: The Alternate Menu does not redirecting to the AMP for the product category in menu items #3915
* Fixed: Sub-Category Archives on AMP page should be connected to Change internal links to AMP option. #3924
* Fixed: Debug warning : Undefined index element #3958
* Fixed: MGID Ads are not loading when the Flexible AMP widget option is enabled in the AMP  #3864
* Fixed: The Close bar is not appearing menu check in mobile iPhone #3964

= 1.0.1 (14th December 2019) =
* Fixed: Telegram as social profile #3754
* Fixed: Give default styling for `<small>` tag. #3879
* Fixed: When pagination is enabled in Category Module,translation option should be given in Advanced. #3847
* Fixed: An issue with Code module in AMP page puilder. #3833
* Fixed: Getting an error while validating page when using Disqus comments #3871
* Fixed: Content is updated programatically on /amp/ page view, bad revision is created #3822
* Fixed: Custom Post types and taxonomies option should be only visible when Archives is enabled #3903
* Fixed: After reloading 'Select Categories to Hide AMP', it shows empty #3898
* Fixed: In exclude Categories option the "No items of this type were found." message is displaying #3900
* Fixed: Cannot use a scalar value as an array #3823
* Fixed: Debug warnings. #3932
* Fixed: Google Tag manager not firing properly #3826

= 1.0.0 (11th December 2019) =
* Improvement: Need to clear amp treeshaking css for reset section button. #3916
* Improvement: Need to add easy table of contents in extension list #3922
* Fixed: If hide amp hide on post or pages from anywhere then that needs to redirect to 301 #3767
* Fixed: Need to add filter in "wp_localize_script" #3764
* Fixed: Need to add preload key requests for font icons #3752
* Fixed: Advance footer options should not be hidden by default #3652
* Fixed: Button Rel Attribute #3872
* Fixed: Need to update the PWA for WP extension from the options panel #3888
* Fixed: “View AMP” Button Showing CSS on frontend #3890
* Fixed: Images get streched in new version of the AMP FOR WP Plugin #3914
* Fixed: Need to remove one signal push notification button in pages. #3874
* Fixed: when images are placed along with the anchor tag in gallery module of guntenberg editor the image src is getting unknown in AMP #3923
* Fixed: When RTL is enabled,the menu in header is going to right but the elements in right are not moved to left. #3881

= 0.9.98.22 (9th December 2019) =
* Improvement: Need to add full short pixel plugin compatibility #3782
* Fixed: Need to improve UI when "Saved" notification displays. #3856
* Fixed: Need to show the Attention message when custom AMP editor box checked but there is no content in it #2866
* Fixed: Issue with AMP page builder tool when images are inserted in slider module. #3780
* Fixed: Hidden posts in AMP should not show in related posts #3839
* Fixed: Make header Unsticky not working when Infinite scrolling is turned on. #3831
* Fixed: The post title appears 2 times: after the parent category and after the child on breadcrumb. #3724
* Fixed: data-block-on-consent missing in GTM code #3911
* Fixed: Debug error #3910
* Fixed: PHP Warnings from redux filesystem #3901
* Fixed: Debug notice #3913
* Fixed: Sidebar Widgets Default CSS should load on Woo commerce Sidebar #3912
* Fixed: Images get streched in new version of the AMP FOR WP Plugin #3914

= 0.9.98.21 (3th December 2019) =
* Improvement: Fonts support in all three designs one, two and three along with the swift Theme #1914
* Improvement: Need to create Testimonial slider in AMP Page Builder #2960
* Improvement: Need to create an optional option for the side menu when people click on the text the links should be dropped. links sub links #3428
* Improvement: Need to make compatibility with this plugin Stop Generating Image Sizes #3851
* Improvement: Improve Matemo analytics integration #3757
* Fixed: Breadcrumb breaks when '/' is present in category name #3769
* Fixed: Back to top button CSS loading twice in Design 1,2,3. #3835
* Fixed: Removing trbidi attribute #3687
* Fixed: Upgrade to AdsforWP button not working properly. #3681
* Fixed: Tooltip alignment is missing in Advertisement #3625
* Fixed: Media queries are removing automatically in media queries merging process #3797
* Fixed: Excerpt on homepage is not working properly. #3866
* Fixed: Author links are redirecting to AMP even when the Archives is turned off. #3875
* Fixed: Issue related to image height and width #3857
* Fixed: Gutenberg Gallery Images are not displayed correctly when any option is selected in WordPress Content Gallery. #3868
* Fixed: Google Tag manager not firing properly #3826
* Fixed: After Update AMP option panel design is changing #3877

= 0.9.98.20 (27th November 2019) =
* Fixed: Menu closer icon is getting overlapped by the header part of firefox web browser #3744
* Fixed: Instagram TV videos are not rendering into AMP #3812
* Fixed: Need To move CTA button in header two in sidebar if the website layout is in mobile view #3669
* Fixed: When the image is added from ThirstyAffiliate image block from Guntenber editor facing validation error #3706
* Fixed: PHP Warning:DOMDocument::loadHTML(): Empty string supplied as input #3745
* Fixed: When Convert AMP to WP theme (Beta) option is enabled Back to Top link functionality is not working #3695
* Fixed: Post date always shows 3 hours ago #3624
* Fixed: Gutenberg Design Bugs #3645
* Fixed: Toolbar AMP link bug #3692
* Fixed: Breadcrumb icommon symbol direction should be changed when RTL is enabled in Swift. #3678
* Fixed: Extra CSS are loading in swift and AMP Layouts #3414
* Fixed: Remove Digg and Google plus option form Social Sharing #3709
* Fixed: When Yoast SEO plugin is activated the same excerpt shows #3708
* Fixed: Allow people to use captions below thumbnails in gallery #3702
* Fixed: Design improvements of D2 #3637
* Fixed: Fatal error: Uncaught Error: Cannot use object of type stdClass as array (after 98.15) #3867
* Fixed: In amp gallery need to make improvement in arrow #3860
* Fixed: Performance issues in AMP FOR WP #3732
* Fixed: Yoast Separator is converting from Hyphen to Dash #3783
* Fixed: Multiple UX related modifactions #3869
* Fixed: strpos() debug error after 19 update #3878

= 0.9.98.19 (25th November 2019) =
* Fixed: image transients should clear automatically #3781
* Fixed: CTA button in header could be made no follow #3798
* Fixed: In IOS screen, Menu cross button is not appearing in Swift design #3809
* Fixed: Comment closed opion need to be removed. #3750
* Fixed: In template mode Need to show extension setting panel. #3728
* Fixed: Facebook comment is not changing language when we select another language #3710
* Fixed: Single Sidebar data is visible in Homepage #3636
* Fixed: Need to remove width from inline style on amp images #3741
* Fixed: If permalinks is set as "/index.php/%year%/%monthnum%/%day%/%postname%/" then not working properly with Pagination #3537
* Fixed: Canonical url is changing in cateogry pages when cateogry name start with amp #3694
* Fixed: general fixes and improvements part 2 #3621
* Fixed: Warning: strpos(): Empty needle in /home/statecer/public_html/wp-content/plugins/accelerated-mobile-pages/templates/features.php on line 5788 #3870

= 0.9.98.18 (21th November 2019) =
* Improvement: Show the number of shares with Sassy Social Share #3588
* Fixed: Need to improvment in table code #3664
* Fixed: Change internal links to AMP is not working when custom permalink having the extenison.html #3811
* Fixed: Width of the recent posts and related posts thumbnail image should be same #3639
* Fixed: Page should be full width if the page builder is used #3756
* Fixed: Remove broken link on source code like - link rel="dns-prefetch" #3697
* Fixed: leave a comment added when making pages with pagebuilder #3755
* Fixed: Need to adding gaping for col 2 in AMP Pagebuilder #3796
* Fixed: CSS issue. #3785
* Fixed: Facebook comment is not changing language when we select another language #3710
* Fixed: Verify button of Google Font API key is not working after update #3858
* Fixed: Cache is not clearing after clicking clear cache button #3863

= 0.9.98.17 (19th November 2019) =
* Fixed: Validation error of 'srcset' in 'amp-img' after Latest update of Divi Theme (From version 4.0.2) #3803
* Fixed: Logo is not resizing when using fixed width #3696
* Fixed: Fatal Error when "AMP FOR WP" is activated on AMP FOR WP Garage URL #3765
* Fixed: Images and Videos with Gutenberg does not have proper spacing #3634
* Fixed: Undefined variable: amp_url #3776
* Fixed: amp-image-lightbox markup is loading in paginated post even the image is not present #3700
* Fixed: Search results on/off option in amp #3786
* Fixed: Internal links are breaking in Persian language #3777
* Fixed: Use util function to get array component. Fixes #3778 #3842
* Fixed: Add Hyperlink option to Gallery module images. #3850
* Fixed: Need to remove WPBakery Page Builder Support Option #3855

= 0.9.98.16 (18th November 2019) =
* Improvement: Need to make compatibility of Advance setting options of yoast seo into AMP #3684
* Improvement: Add filter to modify HTML attributes #3685
* Fixed: Jetpack causing errors after update #3849
* Fixed: Facebook like button is not showing correctly after last update in design3 #3742
* Fixed: [URGENT] Vuukle API KEY missing #3792
* Fixed: Admin tool bar css is not loading #3788
* Fixed: Hide button always showing on page #3762
* Fixed: Meta description are not showing properly in genesis #3761
* Fixed: Non-Responsive tables after version 0.9.98.9 #3746
* Fixed: Wrong amphtml when static page is selected in reading settings along with ?amp endpoint #3717
* Fixed: Homepage posts image alignment issue #3691
* Fixed: Lightbox not working for single images #3683
* Fixed: Notice: Undefined index: category #3829
* Fixed: Notice: Undefined variable: category_name #3827
* Fixed: AMP Dev mode when disabled throwing a fatal error in mobile mode for blog. #3824
* Fixed: Warning when trying to save the option #3800

= 0.9.98.15 (15th November 2019) =
* Improvement: New UX for AMP Options Panel #3520
* Improvement: Improvement done in "Want to clear the Cache?" option in Performance section #3828

= 0.9.98.14 (7th OCTOBER 2019) =
* Fixed: Value Attribute Stripping out from the forms added in the content. #3689
* Fixed: Remove AAWP from extension list #3735
* Fixed: Data is not saving while Importing options from the json file #3667
* Fixed: Debug warning #3723, #3729, #3730, #3731

= 0.9.98.13 (27th SEPTEMBER 2019) =
* Improvements: Need to create an option to clear the cache in tree shaking #3680
* Improvements: Only get the required dashicons for Admin Toolbar #3707
* Fixed: When enabling Treeshaking it removes the Swift icons TTF #3665
* Fixed: List numbers are not in position #3704
* Fixed: Menu Auto closing when # in the url #3633
* Fixed: Facebook Like script not loading #3633

= 0.9.98.12 (25th SEPTEMBER 2019) =
* Improvements: User wants Wordpress admin toolbar in the AMP area #3450
* Improvements: we want the amp menu showing from left or right side both. #3095
* Improvements: Add feature to increase width for facebook like button and also add feature of data-action="recommend" #3241
* Improvements: Improvements in Design 1 2 and 3 option panel in Header section #3642
* Fixed: Update Stops Google Analytics tracking #3690
* Fixed: Lightbox not working for single images #3683
* Fixed: Language of Menu not changing when changing website language #3522
* Fixed: We need to allow people to turn off the social section fully #3613
* Fixed: Ui Design issues #3616
* Fixed: Dropcap option should only be enabled on the posts, not from pages. #3614
* Fixed: Social share position is not working in single design 2#3627
* Fixed: AMP text module is not working in Widget area #3644
* Fixed: Social media icons and comments should be below the post content on pages #3647
* Fixed: Breadcrumbs are breaking after enabling ""Post title on Breadcrumb" option #3648
* Fixed: line share link is getting added when sharing on telegram#3666
* Fixed: In social sharing Twitter Handle and Pretty Permalinks for Twitter Share? need to display child option of Twitter#3656
* Fixed: Extension license dashboard improvements #3654
* Fixed: Make the chat bubble into a email box for faster input #405
* Fixed: Option to specify certain taxonomy only in Instant Article Feeds #1489
* Fixed: Need to remove Legacy Pagebuilder option Safely #3609
* Fixed: Default heading tag should load if no option is selected in Header Module #3651
* Fixed: Pretty Permalinks for Twitter Share? option is not working #3662

= 0.9.98.11 (20th SEPTEMBER 2019) =
* Improvements: Improved AMP Advertisement option panel
* Fixed: Mobile redirection causing extra redirects from /amp to /amp/ #3660
* Fixed: The lightbox should not work for the image if any external link is added in its anchor tag. #3599

= 0.9.98.10 (18th SEPTEMBER 2019) =
* Improvements: Upgrade the analtyics integration with gtag.js #3538
* Improvements: Need to optimize css classes #3650
* Fixed: Small sized images are getting stretched in the lightbox. #3602
* Fixed: Gutenberg Audio Module not working #3597
* Fixed: Table (thead-th) styling issue after update #3661
* Fixed: Issue with the post titles in single page (two H2 tags if logo is not inserted) #3641
* Fixed: search results pages are showing up as 'no index' #3646
* Fixed: Need to add support of shortcode in category pages #3653
* Fixed: Custom post description migrates to image description #3606
* Fixed: AMP for WP conflict with the CDN Enabler plugin #3631
* Fixed: Warning in Error Log #3655
* Fixed: Incorrect placeholder "Select the SEO Plugin" in drop-down in AMP option Panel #3663

= 0.9.98.9 (16th SEPTEMBER 2019) =
* Improvements: Need to implement Tree Shaking feature to remove access css from the AMP pages #2949
* Improvements: Need to save Post Meta Field Revisions in WordPress #3548
* Improvements: Add Role based Access to all the options #3480
* Improvements: Need to improve import/export option. #3364
* Improvements: Need to make compatibility with amp-connatix-player component #3524
* Improvements: "Recent Posts below related posts" feature need to implement for the design three #3531
* Improvements: Need to improve color picker library in AMP FOR WP Plugin #3461
* Improvements: Recent Posts below Related needs new options #3518
* Improvements: Excerpt length feature request for related post #2908
* Improvements: Need to add the option date below the content #3445
* Improvements: Need to hide time in traditional view option. #3453
* Improvements: Add feature to go to non AMP page on next and previous links #3253
* Improvements: Create a filter to Exclude Posts from Related Posts #3582
* Improvements: Need to add a filter to remove options in sidebar in AMP #3416
* Improvements: allow option to change the heading tag of Featured module #3560
* Improvements: AAWP plugin for AMP compatibility in Extension list #3591
* Fixed: Individual AMP Page (Bulk Edit) "hide by default" option not working #3610
* Fixed: In Recent Posts below Related need to add which present in below below related post #3596
* Fixed: Need to shift the Header Background Option and Header Elements option on top in Swift theme #3462
* Fixed: Need to add 'By Last X Days' option for "In-Content Related Posts" #3219
* Fixed: Need to add unique class name custom post type #3539
* Fixed: Need to add Convert AMP to WP theme (Beta) tutorial link in tooltip of this option #3552
* Fixed: Need to connect with Collapse references by default option of the footnotes plugin. #3586
* Fixed: Do not generate the AMPhtml for Woocommerce Account Page #3619
* Fixed: Need to place page builder in custom homepage even amp support is off on pages. #2914
* Fixed: Need to allow the user to navigate if user is using iframe #3601
* Fixed: Template mode: Need to changes/fixes #3590
* Fixed: The lightbox should not work for the image if any external link is added in its anchor tag. #3599
* Fixed: Improper amphtml on HomePage when WPML is activate #3341
* Fixed: The GDPR consent not working due to passed as string. #3658

= 0.9.98.8 (7th SEPTEMBER 2019) =
* Improvements: AMP Option panel in mobile view #2603
* Improvements: Need to make compatible with yoast seo primary category option #3551
* Improvements: The "redirect chain" report taking extra steps to process. #3575
* Improvements: Rank math Titles & Meta compatibility #3592
* Improvements: Improvement in iframe #3563
* Improvements: optimize the TEL link to remove validation and provide better UX #3581
* Fixed: Need to check function exist get_cart_url as it is getting fatal error when only amp woocommere is active. #3584
* Fixed: Change Internal Links to AMP #3561
* Fixed: Rare issue with Yoast SEO/Excerpt #3511
* Fixed: lighthouse issues #3547
* Fixed: Gallery Captions not working #3536
* Fixed: Table is not aligning properly in amp version #3549
* Fixed: Getting Debug error ( cdn_url_main ) #3555
* Fixed: Delete button gone in page builder in RTL language #3545
* Fixed: caption design is different when comparing Gutenberg and classic editor #3573
* Fixed: Image is not aligned properly #3542
* Fixed: The extension 'amp-wistia-player' was found on this page, but is unused. Please remove this extension. #3587
* Fixed: No Index issue #2303
* Fixed: Need to create a basic tutorial for each elements of single in Swift #3499
* Fixed: Facebook like button is not aligned properly #3589
* Fixed: h1 was changed to h2 in the custom frontpage title after update #3546
* Fixed: When using JNews AMP Extender, It makes posts blank #3526
* Fixed: Infinite scroll script is adding in woocommerce archive pages #3570
* Fixed: Clicky analytics option getting hidden when GTM is on #3585
* Fixed: In add on mode when amp is in standard mode frontend is getting blank screen. #3508
* Fixed: Proper escaping in facebook instant article #3564
* Fixed: No Icon in Facebook Message when Font Awesome Icon type selected #3572
* Fixed: yoast breadcrumb making all ul list in capital letters #3540
* Fixed: Comments should be removed in the out put of Analytics Code #3593
* Fixed: Related post excerpt is not working with horizontal design #3595
* Fixed: Issue in Breacrumb if category has a comma #3598
* Fixed: After last update the cookie bar text shows the html code (a href) instead of creating a link. #3617

= 0.9.98.6 (31th AUGUST 2019) =
* Improvements: Structured Data improvements #3567
* Improvements: Addthis share button's postion field in 1,2 and 3 designs #3553
* Fixed: Rare issue AMP settings are not getting saved showing popup error "There was a problem with your action. Please try again or reload the page." #3494
* Fixed: Plugin removes Telegram links #3578
* Fixed: amp-addthis validation error on pages #3580
* Fixed: Spot.IM Comments not working on all designs #3568
* Fixed: Incorrect title tags being generated #3565
* Fixed: Reduce the size of auto inline css. #3115

= 0.9.98.5 (27th AUGUST 2019) =
* Improvements: Compatibility integrated with CDN enabler #3515
* Improvements: banner ux section of AMP panel settings improved #3470
* Improvements: Reduces the size of auto inline css ro avoid validation errors #3115
* Improvements: Tooltip to show description about "Social Share links to AMP" and "No Follow All Your Social Links" #3456
* Improvements: Avada pagebuilder compatibility feature integrated ( it will work when 'AMP PageBuilder Compatibility' extension is activate) #3550
* Improvements: Avia pagebuilder(Enfold) feature integrated ( it will work when 'AMP PageBuilder Compatibility' extension is activate) #3559
* Improvements: Filters to show or hide option on admin settings for Template-mode #3562
* Fixed: When AMP Page builder is checked with Empty Content,Container is missing on AMP view #3488
* Fixed: Validation error when adding featured video with Authentic theme #3535
* Fixed: User Experience issue with Custom Home Page #2348
* Fixed: Serach option should be enabled by default when user selected the design-3 #3485
* Fixed: Logo's resize option should only display when the image is present #3471
* Fixed: Row module settings popup header is overlapped while scrolling the options in AMP Page Builder #3467
* Fixed: labeling of the 'Text font' option in 'Row module settings' of AMP Page builder renamed #3468
* Fixed: When AMP takeover is enabled, the 'visit amp' on admin header should disabled #3502
* Fixed: Homepage amphtml not getting generated when there are no posts added. #3504
* Fixed: AMP cache description is getting overlap with the Checkbox description when amp cache extension is activate #3512
* Fixed: Category module's pagination of AMP Page builder is not working #3509
* Fixed: There is closing tag of 'a' tag in header-bar.php of design bar, for which there is no opening tag #3479
* Fixed: Icons not loading When Icon Font Library is selected to Font Awesome from the AMP options #3501
* Fixed: Shortcode placed with double brackets (i.e., [[shortcode]]) should not execute #3481
* Fixed: One signal push notification should work properly on AMP if any CDN plugin is used #3340
* Fixed: Extra options are being displayed after the search is completed in the AMP Options Panel #2874
* Fixed: In alt attribute's content single quotes should removed #3492
* Fixed: "amphtml" is not generatiing in sorce code when it comes to search results pages in non AMP #3458
* Fixed: Woocommerce archives and shop page support should not be dependent on Archives [Category & Tags] option #3558
* Fixed: noreferrer is getting added automatically, it should have what ever the user passes #3566

= 0.9.98.4 (6th AUGUST 2019) =
* Improvements: Pagebuilder Compatibility Options in 'AMP By Automattic' Addon Mode Settings #3507
* Fixed: Design is breaking in swift theme when RTL option is enabled #3527
* Fixed: Validation error when width and height is empty in the logo #3530
* Fixed: 'Read more' link in excerpt for category module of AMP page builder #3510
* Fixed: Mobile redirection causing extra redirects from /amp to /amp/ #3459
* Fixed: "Recent Posts below Related Posts" option should show only when it is available for the theme #3528

= 0.9.98.3 (2nd AUGUST 2019) =
* Improvements: OpenGraph Support in AMP #3261
* Improvements: Compatibility integrated with Cloudflare stream. #3230
* Improvements: Pagebuilder Compatibility Options in 'AMP By Automattic' Addon Mode Settings #3507
* Improvements: Some changes in AMP panel setting's defaults #3065
* Fixed: Search bar is messed up after 3425 and 3000 #3491
* Fixed: Lightbox effect not working with "Tablepress" when "Link To" option is selected in Attachment display settings #3451
* Fixed: Fatal error Uncaught Error: Call to undefined function ampforwp_is_non_amp() #3464
* Fixed: Ol and li design issue in swift theme on RTL mode #3457
* Fixed: When AMP Page builder is checked with Empty Content, Container is missing on AMP view #3488
* Fixed: rel=”nofollow” is getting replaced by rel=”noreferrer in links #3483
* Fixed: In Archives Category & Tags option is disabled, the link should go to non-amp #3486
* Fixed: Multiple H1 Tag Issues in AMP Version on Home and Category Pages in Design 3 #3466
* Fixed: Allow href attribute value with associated apps property #3475
* Fixed: Validation errors in amp category page when HotWP PRO theme is active #3455
* Fixed: Compatibility issue with WP Offload Media Lite. #3460
* Fixed: Fatal error Uncaught Error: Call to undefined method RevSliderFunctionsWP::check_for_shortcodes() #3465
* Fixed: If a title is loading then only its markup should load otherwise not #3495
* Fixed: In Template mode feature, some fixes #3478
* Fixed: Meta description option should be enabled by default SEO #3505
* Fixed: Fatal error Uncaught Error Class 'AMPforWP\AMPVendor\WP_Error' not found #3514
* Fixed: After the upgrade, AMP Page Builder is not working! #3506
* Fixed: Page builder content getting blank when we hit save. #3513
* Fixed: Wp editor not loading when Using Page builder (with Gutenberg) #3517
* Fixed: Single design 2 in Swift broken in one specific use case #3532

= 0.9.98.2 (25ND JULY 2019) =
* Fixed: Menu design issue in Design 3 #3489
* Fixed: Fatal error when latest version of Smush pro plugin activated #3487
* Fixed: After Version 0.9.98 update, Background Type gradient options are not showing in Row module of AMP pagebuilder #3490* Fixed: Undefined index ampforwp-amp-on-off #3474
* Fixed: Search bar is not showing in design three after enabling the search option in header option panel #3484
* Fixed: Content blank if Color Attribute is in Span tag #3497
* Fixed: Sticky Header has no background color when scrolling. #3498

= 0.9.98.1 (22nd July 2019) =
* Fixed: Logo and headline comes togeather after .98 update #3472
* Fixed: Default loading message as '1' in search bar after latest update (.98) #3476

= 0.9.98 (19th July 2019) =
* Improvements: Option to remove date from Homepage and also in Recent posts #3363
* Improvements: Option for amp-youtube Embed video attributes in row module of AMP Pagebuilder #3373
* Improvements: Menu sidebar background and elements color changing option for Design 1, 2 #3402
* Improvements: MGID Ad support in AMP FOR WP #3431
* Improvements: Sizes of featured image option for single 1 #3433
* Improvements: Addthis floating share button feature in amp #3424
* Improvements: Wistia Plugin Compatibility integrated #3386
* Improvements: Squirrly SEO  Compatibility integrated #3421
* Improvements: image-slider compatibility added in AMP sanitizer #3422
* Improvements: Compatability issue with ShortPixel Image Optimizer #3439
* Improvements: Improve the Search form (Sidebar) design #3425
* Improvements: AMP footer widget in design three #3411
* Improvements: Extension list added for AMP Email Extension #3144
* Improvements: Extension list added for Pinterest for AMP Extension #3195
* Improvements: Extension list added for Liveblog For AMP Extension #3194
* Fixed: Close menu button is not showing when a user comes from Google search #3401
* Fixed: When High-resolution Images option is enabled images link should be generated from higher-order to lower-order in schema markup #3442
* Fixed: Sticky Social Icons setting should be moved to Social Tab and some changes #3426
* Fixed: Fall back the header type code in the backend if a user has not selected any header type #3419
* Fixed: Revolution Slider not working perfectly when a user is inserting video #3311
* Fixed: Call to action option should be automatically enabled if the user selected header type-2 #3420
* Fixed: Double quotes on the author area #3441
* Fixed: Twitter URL is displaying instead of an icon when Zox news theme is active #3409
* Fixed: Extension code array issue #3438
* Fixed: Validation error due to amp-facebook-like #3427
* Fixed: Fatal error cannot redeclare is_amp_endpoint() (previously declared) #3415
* Fixed: Sticky Social Icons and cookies banner style issue #3452
* Fixed: Validation error the extension 'amp-next-page' was found on this page, but is unused please remove this extension #3463
* Fixed: gallery/slider module is not working when Convert AMP to WP theme (Beta) option is enabled #2771

= 0.9.97.65 (16th July 2019) =
* Fixed: PHP Warning at the top of the site: array_merge(): Expected parameter 1 to be an array #3434
* Fixed: Disqus comment is not working after version 0.9.97.63 #3446
* Fixed: Uncaught Error: Call to undefined method WPSEO_Options::get() for Yoast Premium #3447
* Fixed: Message: when Leverage Browser Caching is not supported #3449
* Fixed: Added the missing parameter $depth in filter 'nav_menu_item_id' #3454

Full changelog available [ at changelog.txt](https://plugins.svn.wordpress.org/accelerated-mobile-pages/trunk/changelog.txt)